var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./mappings"], factory);
    }
})(function (require, exports) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.stringToRegex = void 0;
    var mappings_1 = require("./mappings");
    function mergeMappings(innerMappings, strongMapping) {
        var base = {};
        var codes = !strongMapping ? mappings_1.classicCharCodes : mappings_1.fullCharCodes;
        for (var code in codes) {
            base[code] = codes[code];
        }
        if (innerMappings) {
            for (var mapping in innerMappings) {
                base[mapping] = innerMappings[mapping];
            }
        }
        return base;
    }
    function replacer(input, mappings) {
        return input
            .split('')
            .map(function (letter) {
            for (var mapping in mappings) {
                if (mapping &&
                    mapping !== mappings[mapping] &&
                    (mapping === letter || mappings[mapping].indexOf(letter) !== -1)) {
                    letter = Array.isArray(mappings[mapping]) ? mappings[mapping].join('') : "[" + mappings[mapping] + "]";
                    break;
                }
            }
            return letter;
        })
            .join('');
    }
    function optionsToFlag(options) {
        if (typeof options.flags === 'string' ||
            options.caseinsensitive ||
            options.global ||
            options.multilines ||
            options.unicode) {
            var flags = ['i'];
            if (typeof options.flags === 'string') {
                flags = [''];
                options.caseinsensitive = options.global = options.multilines = options.unicode = false;
                flags.push(options.flags);
            }
            if (options.multilines === true) {
                flags.push('m');
            }
            if (options.unicode === true) {
                flags.push('u');
            }
            if (options.global === true) {
                flags.push('g');
            }
            if (options.caseinsensitive === true) {
                flags.push('i');
            }
            else {
                var index = flags.indexOf('i');
                if (index > -1) {
                    flags.splice(index, 1);
                }
                else {
                    flags;
                }
            }
            var set = new Set(flags);
            flags = __spread(set);
            return flags.join('');
        }
        else {
            return 'i';
        }
    }
    /** Generate a function that returns a RegExp, that can be reused with the same options */
    function stringToRegex(options) {
        if (options === void 0) { options = {}; }
        var innerMappings = mergeMappings(typeof options.mappings === 'object' ? options.mappings : null, options.strong);
        return function (input) {
            if (options.spaces) {
                input = input.replace(/\s/g, '').split('').join("(?:\\s|'|-)*");
            }
            return new RegExp(replacer(input, innerMappings).replace(':\\[SsŚśŜŝŞşŠšȘșṠṡṢṣṤṥṦṧṨṩ]', ':\\s'), optionsToFlag(options));
        };
    }
    exports.stringToRegex = stringToRegex;
});
//# sourceMappingURL=index.js.map